/*
 * GChecker.java
 *
 * Created on March 15, 2008, 5:53 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ija.Hanoi.sample5.graphic;

import ija.Hanoi.sample5.model.Checker;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.Rectangle2D;


/**
 *
 * @author koci
 */
public class GChecker {
    
    protected GTower owner;
    protected Checker ch;
    protected Rectangle2D.Double rect;
    protected boolean selected;         // melo by byt i na urovni modelu
    
    /** Creates a new instance of GChecker */
    public GChecker(GTower owner, Checker ch) {
        this.owner = owner;
        this.ch = ch;
        rect = new Rectangle2D.Double();
        reposition();
    }
    
    protected void reposition() {
        int position = owner.getModel().positionOf(ch);
        int size = ch.size();
        int width = size*30;
        int height = 10;
        int x = (owner.getWidth()-width)/2;
        int y = owner.getHeight() - 30 - position * 30;
        rect.setRect(x, y, width, height);        
    }
    
    protected void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        if (selected) {
            g2.setColor(Color.GREEN);
        }
        else {
            g2.setColor(Color.BLACK);            
        }
        g2.draw(rect);
    }
    
    public boolean contains(Point p) {
        return rect.contains(p);
    }
    
    public void selected(boolean s) {
        selected = s;
    }
    
    public Checker getModel() {
        return ch;
    }
    
    public void owner(GTower o) {
        owner = o;
        reposition();
    }

    public GTower owner() {
        return owner;
    }
    
}
