/*
 * GTower.java
 *
 * Created on March 15, 2008, 5:55 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ija.Hanoi.sample5.graphic;

import ija.Hanoi.sample5.model.Checker;
import ija.Hanoi.sample5.model.Tower;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.JPanel;


/**
 *
 * @author koci
 */
public class GTower extends JPanel {
    
    protected Tower tower;
    protected GHanoi owner;
    protected List<GChecker> elements = new ArrayList<GChecker>();
    
    protected boolean drawNot = false;
    
    /** Creates a new instance of GTower */
    public GTower(GHanoi owner, Tower t) {
        this.tower = t;
        this.owner = owner;
        this.setBorder(BorderFactory.createLineBorder(Color.BLACK));
        this.setPreferredSize(new Dimension(150,200));
        this.setSize(new Dimension(150,200));
        this.setBackground(Color.white);
        this.setOpaque(true);
        this.addMouseListener(new CMouseListener());
        for (Checker ch : tower.elementsList()) {
            elements.add(new GChecker(this, ch));
        }
    }

    public Tower getModel() {
        return tower;
    }
    
    protected void remove() {
        elements.remove(this.get());
        getModel().remove();
    }

    protected void add(GChecker gch) {
        elements.add(gch);
        getModel().put(gch.getModel());
        gch.owner(this);
    }
    
    public GChecker get() {
        if (! elements.isEmpty()) {
            return elements.get(elements.size()-1);
        }
        return null;
    }
  
    protected boolean moveChecker(GChecker gch) {
        GTower t = gch.owner();
        if (! equals(t)) {
            if (getModel().canPut(gch.getModel())) {
                t.remove();
                add(gch);
                return true;
            }
        }
        return false;
    }
    
    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        Color c = g.getColor();
        if (drawNot) {
            g.setColor(Color.RED);
        }
        g.drawRect(getWidth()/2 - 5, 20, 10, getHeight() - 40);
        g.setColor(c);
        for (GChecker gch : elements) {
            gch.paintComponent(g);
        }
    }
    
    class CMouseListener implements MouseListener {
        public void mouseExited(MouseEvent ev) {}
        public void mouseEntered(MouseEvent ev) {}
        public void mouseReleased(MouseEvent ev) {}
        public void mousePressed(MouseEvent ev) {}
        public void mouseClicked(MouseEvent ev) {
            GChecker ch = owner.selectedChecker();
            if (ch != null) {
                if (! moveChecker(ch)) {
                    drawNot = true;
                    new Thread(new Runnable() {
                        public void run() {
                            try { Thread.sleep(2000); } catch (InterruptedException ex) {}
                            drawNot = false;
                            repaint();
                        }
                    }).start();
                }
                owner.selectedChecker(null);
                owner.repaint();
            }
            else {
                owner.selectedChecker(null);
                ch = get();
                if (ch != null) {
                    if (ch.contains(ev.getPoint())) {
                        owner.selectedChecker(ch);  
                    }
                    repaint();
                }
            }
        }      
    }
}
